"use strict";
this.name        = "demo";
this.author      = "eric walch";
this.copyright   = "� 2008 eric walch.";
this.description = "Empty script structure that handles population and mission offering";
this.version     = "0.0";

// N.B. Works only with 1.74.


// startUp only runs once at startup before the demoscreen shows up and after loading in a saved game.
this.startUp = function (){
    this.mustPopulate = true;
    /* used for adding ships after a first launch.
    This way you don't have to time consuming check every launch if a ship was already there.
    */
};

this.shipWillDockWithStation = function (station){
    /*
    This is the place to add your messages to the arrival report with:
    if(condition) player.addMessageToArrivalReport(expandDescription("Your message"));
    */
};

this.shipDockedWithStation = function (station){
    // do your stuff here.
};

this.missionScreenOpportunity = function (){
    /*
    This handler triggers:
    - After loading a saved game.
    - After docking.
    - After a missionscreen ended.
    It will only trigger for one oxp at a time and stop triggering when an oxp takes the Opportunity.
    There is no need to do additional tests: when an opportunity is given, it is safe to display a missioncreen.
    */
    if (!player.ship.docked) return;
    this.missionOffers();
};

this.missionOffers = function (){
    if (player.ship.dockedStation.isMainStation) {
        //  Your stuff for the main station
        /*
        Missionscreens are set up using the command:
        mission.runScreen({title: "", messageKey: "", etc...}, this.choiceEvaluation)

        When you do an offer it is often advisable to set a variable to tell an offer is made. (e.g. this.offering)
        This prefents comming in a loop of offering. There is no need to use a missionVarriable for this,
        a "this.Foo" will do. But always remember that a player can launch without making a selection, so
        you must clear such variables on launch.
        */
    } else if (player.ship.dockedStation.shipDescription == "My Station"){
        // Your stuff for a special named station
    }
};

this.choiceEvaluation = function (choice){
    if (this.offering === "MY_OFFER"){
         /*
         the choise is only offered to the oxp that created the page, so there is no longer the risk
         of other oxp reacting on a chosen answer.
         */
        if (choice === "YES_MISSION"){
            // put your code here.
        }else{
            if (choice === "NO_MISSION"){
                // put your code here
            }
        }
    }
    this.offering = null;
};

this.setUpShips = function (){
    // Put here your code that populates the system.
};

this.shipExitedWitchspace = function (){
    if (system.isInterstellarSpace) return;
    this.setUpShips();
    // Put here your code else than setting ships up.
};

this.playerEnteredNewGalaxy = function (Galaxy){
    // This handler will be rarely needed.
};

this.shipLaunchedFromStation = function (){
   /* The first launch after a restart the system must be populated after a launch.
   The other times it happens after a WitchspaceJump */
   if (this.mustPopulate) {this.setUpShips(); this.mustPopulate = false}
   this.offering = null; // in case a ship launched from within a missionscreen without making a choice.
    // put here your other code.
};