"use strict";
this.name           = "upsPrivateEscort";
this.author         = "Eric Walch";
this.copyright      = "2008 eric walch";
this.description    = "Script for the escorts as equipment";
this.license        = "CC BY-NC-SA 3.0";


this.shipDied = function()
{
    if (missionVariables.ups_private_escorts > 0) --missionVariables.ups_private_escorts
    player.consoleMessage("Trainee escort died, " + missionVariables.ups_private_escorts + " escorts left.", 6)
}

this.findPlayerHostiles = function()
{
    function isHostileToPlayer(entity)
    {
        return (entity.isShip && entity.target && entity.target === player.ship && entity.hasHostileTarget);
    }
    if (this.ship.target == player.ship && player.ship.target && player.ship.target.bounty > 10)
    {
        this.ship.target = player.ship.target
        this.ship.reactToAIMessage("TARGET_FOUND");
        //log(this.name, "UPS escort is going to attack: "+this.ship.target.name);
        this.sendMessage("I'll help you killing that "+this.ship.target.name+".")
    }
    else
    {
        var targets = system.filteredEntities(this, isHostileToPlayer, this.ship, this.ship.scannerRange)
        if (targets.length > 0)
        {
            this.ship.target = targets[0];
            this.ship.reactToAIMessage("TARGET_FOUND");
            //log(this.name, "UPS escort is going to attack: "+targets[0].name);
            this.sendMessage("I'll take care of the "+this.ship.target.name+".")
        }
        else this.ship.reactToAIMessage("NOTHING_FOUND");
    }
}

this.signOn = function()
{
    if(missionVariables.ups_private_escorts == 1) this.sendMessage("I'll escort you.")
    else this.sendMessage("All " + missionVariables.ups_private_escorts + " of us will escort you.")
}

this.searchMother = function()
{
    this.ship.target = player.ship;
}

this.sendMessage = function(message)
{
	if (worldScripts["ups_docs"].messageAllowed()) this.ship.commsMessage(message)
    // no messages within 5 secs to avoid screen clutter.
}


/*
This is currently not working because of mass locking.
Should work with Oolite 1.75 in a different form though because of the introduced player wormhole.

this.playerWillEnterWitchspace = function ()
{
    if (missionVariables.ups_private_escorts && missionVariables.ups_private_escorts > 0)
    {
        this.ship.fuel = 7;
        this.ship.position = new Vector3D(-10E6*Math.random(), -50E8*Math.random(), -60E9);
        var success = this.ship.exitSystem(player.ship.targetSystem);
        if (!success) log(this.ship, "A private escort had a mass lock problem");
    }
}
*/
