"use strict";

this.name        = "ups_slaves";
this.author      = "eric walch";
this.copyright   = "2008 eric walch.";
this.license     = "CC BY-NC-SA 3.0";
this.description = "Slaves missions of UPS Courier";

this.startUp = function ()
{
    this.mark = false;
    this.upsMarkSystem = worldScripts["ups_docs"].upsMarkSystem;
    this.upsUnmarkSystem = worldScripts["ups_docs"].upsUnmarkSystem;
}

this.startUpComplete = function() 
{
    // fixing issue where ups_slaves hasn't been initialised properly.
    //if (this.ups_slaves == null) this.ups_slaves = "NO";
}

this.shipLaunchedFromStation = function ()
{
  if (this.ups_slaverescue)
  {
    this.setUpShips();
  }
}

this.missionScreenOpportunity = function ()
{
    // this.ups_slaverescue is set to "true" by a scooping a special escape_pod generated by a cobraIII.
    if (player.ship.docked && this.ups_slaverescue)
    {
        this.missionOffers();
    }
}

this.guiScreenChanged = function (newScreen, oldScreen)
{
    if (this.restartMissionOffer && newScreen !== "GUI_SCREEN_LONG_RANGE_CHART")
    {
        this.restartMissionOffer = false;
        if (guiScreen !== "GUI_SCREEN_MISSION") this.missionOffers();
    }
}

this.missionOffers = function ()
{
    if (this._savedTargetSet) player.ship.targetSystem = this._savedTarget
    this._savedTarget = null;
    this._savedTargetSet = false;

	var slaveStatus = this.ups_slaves;
    if (player.ship.dockedStation.isMainStation)
    {
        if (slaveStatus === "SLAVE" && !worldScripts["ups_docs"].lookLongRangeChartScreen)
        {
            var message = expandMissionText("ups_slave_homeland", {ups_slavename: this.ups_slavename});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message,
                                overlay: this._overlay(), choicesKey: "ups_slave_accepted_yesnolook"},
                                this.choiceEvaluation);
            this.offering ="UPS_SLAVES_HOMELANDS";
        }
        if (slaveStatus === "HOMELAND" && this.ups_slplanet === system.ID)
        {
            this.ups_slaves = "NOT_NOW";
            this.upsUnmarkSystem(this.ups_slplanet, this.name);
            var message = expandMissionText("ups_slave_homeland2", {ups_slavename: this.ups_slavename});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message, overlay: this._overlay()});
            mission.setInstructionsKey(null);
            player.ship.manifest["gem_stones"] += 15;
            this.ups_slcount++;
            player.increasePassengerReputation();
        }
        if (slaveStatus === "RESCUEOFFER" && system.government > 3 && system.economy < 3 && !worldScripts["ups_docs"].lookLongRangeChartScreen)
        {
            var message = expandMissionText("ups_slave_rescueoffer", {ups_slavename: this.ups_slavename});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message,
                            overlay: this._overlay(), choicesKey: "ups_slave_accepted2_yesnolook"},
                            this.choiceEvaluation);
            this.offering ="UPS_SLAVES_RESCUE";
        }
        if (slaveStatus === "RESCUE" && system.ID === this.ups_sl2planet)
        {
			if (this.ups_convoy === "KILLED")
			{
				var key;
                if (this.ups_sl2count > 10)
				{
					// rescued all
                    key = "ups_slave_rescue10";
                    player.ship.manifest["gem_stones"] += 50;
				}
				else
				{
					if (this.ups_sl2count > 0) key = "ups_slave_rescue"
					else key = "ups_slave_rescue0"; // rescued none!
				}
                var message = expandMissionText(key, {ups_slavesrescued: this.ups_sl2count, ups_slavename: this.ups_slavename});
                mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message});
				this.resetConvoyMission();
				this.ups_slcount += 3;
			}
			else if (this.ups_convoy === "ADDED" && system.countShipsWithRole("ups-slaveconvoy") === 0)
			{
                var message = expandMissionText("ups_slave_rescue_failure", {ups_slavename: this.ups_slavename});
				mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message});
				this.resetConvoyMission();
				this.ups_slcount -= 2;
			};
        }
        if (slaveStatus === "FINALOFFER" && system.government > 2)
        {
            var message = expandMissionText("ups_slave_final", {ups_slavename: this.ups_slavename});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message,
                            choicesKey: "ups_slave_accepted_yesno"}, this.choiceEvaluation);
            this.offering = "UPS_SLAVES_FINAL";
        }
        if (slaveStatus === "FINAL" && this.ups_slplanet === system.ID)
        {
            this.ups_slaves = "GROUNDBATTLE";
            var message = expandMissionText("ups_slave_groundbattle", {ups_slavename: this.ups_slavename});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message, model: "ups_slave_satellite", spinModel: false});
            this.$startCallback();
            mission.setInstructionsKey("ups_slave_groundbattle_small");
            this.ups_slavesrescued = 5;
        }
        if (slaveStatus === "DEBRIEFING" && this.ups_slplanet === system.ID)
        {
            this.ups_slaves = "NOT_NOW";
            mission.setInstructionsKey(null);
            var key;
            if (this.ups_slavesrescued == 5)
            {
                key = "ups_slave_debriefing"; // rescued all
                player.credits += 6000;
            }
            else
            {
                if (!this.ups_slavesrescued)
                {
                    key = "ups_slave_debriefing2"; // rescued none
                }
                else
                {
                    key = "ups_slave_debriefing1";
                    player.credits += 4000;
                }
            }
            var message = expandMissionText(key, {ups_slavesrescued: this.ups_slavesrescued});
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", message: message});
            mission.setInstructionsKey(null);
			this.upsUnmarkSystem(this.ups_slplanet, this.name);
            this.resetSlaves(galaxyNumber);
            return;
        }
    }
    if (player.ship.dockedStation.name === "Ground Radar")
    {
        if (slaveStatus === "DEBRIEFING" || slaveStatus === "GROUNDBATTLE")
        {
            this.ups_slaves = "FAILED";
            mission.runScreen({screenID: "ups-slaves", title: "Slave Mission", messageKey: "ups_slave_trapped"});
			this.upsUnmarkSystem(this.ups_slplanet, this.name)
            this.resetSlaves(galaxyNumber);
            // should this end the game now?
        }
    }
}

this.choiceEvaluation = function (choice)
{
    switch (this.offering)
    {
        case "UPS_SLAVES_HOMELANDS":
        {
            this.mark = false
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_slplanet, this.name);
                mission.setInstructions(expandMissionText("ups_slave_small", {ups_slavename: this.ups_slavename}));
                this.ups_slaves = "HOMELAND";
            }
            else if (choice === "LOOKSlave")
            {
                this.upsShowDestination(this.ups_slplanet);
            }
            else if (choice === "NOSlave")
            {
                this.ups_slaves = "NOT_NOW";
                if (Math.random()<0.5) player.decreasePassengerReputation();
            }
            break;
        }

        case "UPS_SLAVES_RESCUE":
        {
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_sl2planet, this.name);
                mission.setInstructionsKey("ups_slave_small3");
                this.ups_slaves = "RESCUE";
                this.ups_sl2count = 0;
                this.ups_convoy = null;
            }
            else if (choice === "LOOKSlave")
            {
                this.upsShowDestination(this.ups_sl2planet);
            }
            else if (choice === "NOSlave")
            {
                this.ups_slaves = "NOT_NOW";
            }
            break;
        }

        case "UPS_SLAVES_FINAL":
        {
            if (choice === "YESSlave")
            {
                this.upsMarkSystem(this.ups_slplanet, this.name);
                mission.setInstructions(expandMissionText("ups_slave_small2", {ups_slavename: this.ups_slavename}));
                this.ups_slaves = "FINAL";
            }
            else if (choice === "NOSlave")
            {
                this.ups_slaves = "NOT_NOW";
            }
            break;
        }
        default: log(this.name, "Encountered an illegal mission offer: "+this.offering);
    }
    this.offering = null;
}

this.upsShowDestination = function (ID)
{
    if (!this._savedTargetSet) this._savedTarget = player.ship.targetSystem;
    this._savedTargetSet = true;
    
    this.mark = true; // Keep this selected system.
    if (player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") == "EQUIPMENT_OK")
    {
        player.ship.targetSystem = ID;
        mission.runScreen({title: "Long Range Chart", screenID:"ups-map", backgroundSpecial: "LONG_RANGE_CHART_SHORTEST"});
    }
    else
    {
        mission.markSystem({
            system: ID,
            name: "ups_marker",
            markerColor: "cyanColor",
            markerScale: 2.0,
            markerShape: "MARKER_DIAMOND"
        })
        var message = expandMissionText("ups_long_range_screen", {ups_system: System.systemNameForID(ID)});
        mission.runScreen({title: "Long Range Chart", screenID:"ups-map", message: message, backgroundSpecial: "LONG_RANGE_CHART"});
    }
}

this.setUpShips = function ()
{
    if (this.ups_slaves === "GROUNDBATTLE")
    {
        if (system.ID === this.ups_slplanet && system.countShipsWithRole("ups_slave_satellite") === 0)
        {
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0, 0, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0, 0.05, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0.05, 0, 1.004]);
            //system.legacy_addShipsAtPrecisely("ups_slave_satellite", 1, "pwp", [0.05, 0.05, 1.004]);
            system.addShips("ups_slave_satellite", 1, Vector3D(0, 0, 1.008).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0, 0.05, 1.008).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0.05, 0, 1.008).fromCoordinateSystem("pwp"), 1);
            system.addShips("ups_slave_satellite", 1, Vector3D(0.05, 0.05, 1.008).fromCoordinateSystem("pwp"), 1);
            this.ups_satellitecount = 4;
            // Smallest planet radius = 30 000 meters. 0.004*30 000 = 120 meters. This just fits for the towers.
            // phkb: adjusted to 0.008, as the planet is rotating and the radars are not being moved with the planet
            //       so having them slightly more above the surface reduces the break in mimesis
        }
    }
    if (this.ups_slaves === "RESCUE")
    {
        if (system.ID === this.ups_sl2planet && system.countShipsWithRole("ups-slaveconvoy") === 0 && !this.ups_convoy)
        {
            log(this.name, "adding ups-convoy-l to system");
            system.addShipsToRoute("ups-convoy-l", 1, 0.5, "wp");
			this.ups_convoy = "ADDED";
        }
    }
}

this.shipExitedWitchspace = function ()
{
    if (system.isInterstellarSpace) return;
    if (this.ups_slaverescue)
    {
        this.setUpShips();
        if (!this.ups_slaves)
        { // selection of a target system for all slave missions. And make sure you don't select a Nova system.
            if (system.government === 2 && system.economy > 5 && !system.sun.hasGoneNova && !this.ups_splanet)
            // original had ' && (!system.info.hasOwnProperty("market") || !system.info.market)' in above clause
            // replaced with " && !this.ups_splanet"
            // even this clause may not be required
            {
                this.ups_slaves = "NO";
                this.ups_slplanet = system.ID;
                missionVariables.ups_slplanetname = system.name;
                this.ups_slcount = 0;
                missionVariables.ups_slplanetdescription = system.description;
                system.description += " Currently this planet is in civil war and is selling a lot of its inhabitants as slaves.";
                //system.info.market = "ups_slaveplanet";
                // There are a couple of options here to do the update of the slave market.
                // We could create an updateGeneralCommodityDefinition or updateLocalCommodityDefinition routine
                // but the downside is that we would have to change the logic for the decision making process,
                // changing the time the decision is made to be before we exit witchspace.
                // To keep the logic as similar to the original as possible, we're instead going to force an
                // update to market prices and quantities after the system is generated.
                // We're assuming that the only thing that needs to be adjusted is the "slaves" price and quantity,
                // and that all other trade goods remain the same.
                this._updateLocalSlaveMarket();
                // we should only have to do this once, as the adjusted definition will be saved and restored
                // as part of a player save game.
            }
        }
        var slaveStatus = this.ups_slaves;
        if (slaveStatus === "NOT_NOW" && Math.random() < 0.11) this.ups_slaves = "NO";
        if (slaveStatus === "NO")
        {
            if (this.ups_slcount > 5 && system.government > 2 && Math.random() > 0.9)
            {
                this.ups_slaves = "FINALOFFER";
            }
            else if (this.ups_slcount > 1 && Math.random() > 0.9 && system.government === 2 && !system.sun.hasGoneNova)
            {
                this.ups_slaves = "RESCUEOFFER";
                this.ups_sl2planet = system.ID;
                missionVariables.ups_sl2planetname = system.name;
            }
            else if (!system.isInterstellarSpace && Math.random() > 0.75 && system.economy < 3)
            {
                log(this.name, "adding ups-slavecobra ship to system");
                system.addShipsToRoute("ups-slavecobra", 1, Math.random() * 0.8 + 0.1); // station route
            }
        }
    }
    else if (system.government === 2 && Math.random() > 0.5)
    {
        log(this.name, "adding ups_slave_start ship to system");
        system.addShipsToRoute("ups_slave_start", 1, Math.random(), "wp");
    }
}

this.resetConvoyMission = function ()
{
    this.ups_sl2count = null;
    this.upsUnmarkSystem(this.ups_sl2planet, this.name);
    this.ups_sl2planet = null;
    missionVariables.ups_sl2planetname = null;
    this.ups_convoy = null;
    mission.setInstructionsKey(null);
    this.ups_slaves = "NOT_NOW";
}

this.resetSlaves = function (galaxy)
{
    // do some cleanup of variables
    mission.setInstructionsKey(null)
	if (missionVariables.ups_slplanetdescription)
	{
		System.infoForSystem(galaxy, this.ups_slplanet).description = null;
        /*if (System.infoForSystem(galaxy, this.ups_slplanet).hasOwnProperty("market"))
        {
            System.infoForSystem(galaxy, this.ups_slplanet).market = null;
        }*/
		missionVariables.ups_slplanetdescription = null;
	}
    var deletions = ["slavename", "slplanetname", "sl2count", "sl2planetname"];
    for (var i = 0; i < deletions.length; i++) delete missionVariables["ups_" + deletions[i]];
    var deletions2 = ["slaves", "slaverescue", "slplanet", "sl2planet", "slcount", "slavesrescued"];
    for (var i = 0; i < deletions2.length; i++) this["ups_" + deletions2[i]] = null;
}

this.playerEnteredNewGalaxy = function (galaxy)
{
	if (this.ups_slaves)
	{
		var oldGalaxy = --galaxy;
		if (oldGalaxy < 0) oldGalaxy = 8;
		this.resetSlaves(oldGalaxy);
	}
}

this.$startCallback = function ()
{
    if (!isValidFrameCallback(this.$callbackID)) this.$callbackID = addFrameCallback(this.rotateDisplayModel.bind(this));
    this.displayModel = mission.displayModel;
}

this.rotateDisplayModel = function (delta)
{
    if (guiScreen != "GUI_SCREEN_MISSION" || !mission.displayModel || this.displayModel != mission.displayModel)
    {
        // we are finisched, or the missionscreen has changed.
        this.$cleanupCallback();
        return;
    };
    var q = new Quaternion(1,0,0,0);
    q = q.rotateY(0.1 * delta);
    mission.displayModel.orientation = mission.displayModel.orientation.multiply(q);

}

this.$cleanupCallback = function ()
{
	if (this.$callbackID && isValidFrameCallback(this.$callbackID))
	{
		removeFrameCallback(this.$callbackID);
        delete this.$callbackID;
	}
}

this._overlay = function() {
    if (player.ship.hudHidden || player.ship.hudAllowsBigGui) {
        return {name:"upsnews-large.png", height:546};
    } else {
        return {name:"upsnews-small.png", height:546};
    }
}

this._updateLocalSlaveMarket = function() {
    var oldDefs = [0, 0, 52, -3, -5, 8, 7, 31, 0 ];
    var market_base_price = oldDefs[2];
    var market_eco_adjust_price = oldDefs[3];
    var market_eco_adjust_quantity = oldDefs[4];
    var market_base_quantity = oldDefs[5];
    var market_mask_price = oldDefs[6];
    var market_mask_quantity = oldDefs[7];
    var market_rnd = Math.floor(Math.random() * 256);

    var economy = system.economy;

    var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
    price *= 0.4;

    var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
    if (quantity > 127) quantity = 0;
    quantity &= 63;

    system.mainStation.setMarketPrice("slaves", price * 10);
    system.mainStation.setMarketQuantity("slaves", quantity);
}